from pandac.PandaModules import PerspectiveLens
from pandac.PandaModules import NodePath,LightAttrib
from pandac.PandaModules import AmbientLight,DirectionalLight
from pandac.PandaModules import PointLight,Spotlight
from pandac.PandaModules import Vec3,Vec4


class disco:
    
    def __init__(self, pos = (0,50,-4)):

        self.disco = loader.loadModel('models/disco_hall')
        self.disco.reparentTo(render)
        dx, dy, dz = map(lambda x,y: x-y, pos, (0,50,-4))
        self.disco.setPosHpr(0+dx, 50+dy, -4+dz, 90, 0, 0)

        self.lightAttrib = LightAttrib.makeAllOff() 
        self.ambientLight = AmbientLight( "ambientLight" )
        self.ambientLight.setColor( Vec4( .2, .2, .2, 1 ) )
        self.lightAttrib = self.lightAttrib.addLight( self.ambientLight )

        self.directionalLight = DirectionalLight( "directionalLight" )
        self.directionalLight.setColor( Vec4( .7, .7, .7, 1 ) )
        
        self.directionalLight.setDirection( Vec3( 1, 1, -2 ) )
        self.lightAttrib = self.lightAttrib.addLight( self.directionalLight ) 
    
        self.spotlight = Spotlight( "spotlight" )
        self.spotlight.setColor( Vec4( .9, .9, .9, 1 ) )
        self.spotlight.setLens( PerspectiveLens() )
        self.spotlight.getLens().setFov( 16, 16 )
        self.spotlight.setAttenuation( Vec3( 1, 0.0, 0.0 ) ) 
        self.spotlight.setExponent( 60.0 )

        camera.attachNewNode( self.spotlight.upcastToLensNode() ) 
        self.lightAttrib = self.lightAttrib.addLight( self.spotlight )
    
        self.redPointLight = PointLight( "redPointLight" )
        self.redPointLight.setColor( Vec4( .7, 0, 0, 1 ) )
        self.redPointLight.setAttenuation( Vec3( .1, 0.04, 0.0 ) ) 
        self.redHelper = loader.loadModelCopy('models/sphere')
        self.redHelper.setColor( Vec4( 1, 0, 0, 1 ) )

        self.redHelper.attachNewNode( self.redPointLight.upcastToPandaNode() ) 
        self.redHelper.setPos( -6.5+dx, -3.75+dy, 0+dz)
        self.redHelper.setScale(.25)
    
        self.greenPointLight = PointLight( "greenPointLight" )
        self.greenPointLight.setAttenuation( Vec3( .1, .04, .0 ) ) 
        self.greenPointLight.setColor( Vec4( 0, .7, 0, 1 ) )
        self.greenHelper = loader.loadModelCopy('models/sphere')
        self.greenHelper.setColor( Vec4( 0, 1, 0, 1 ) )
        self.greenHelper.attachNewNode( self.greenPointLight.upcastToPandaNode() )
        self.greenHelper.setPos( 0+dx, 7.5+dy, 0+dz )
        self.greenHelper.setScale(.25)
    
        self.bluePointLight = PointLight( "bluePointLight" )
        self.bluePointLight.setAttenuation( Vec3( .1, 0.04, 0.0 ) ) 
        self.bluePointLight.setColor( Vec4( 0, 0, .7, 1 ) )
        self.bluePointLight.setSpecularColor( Vec4( 1 ) )
        self.blueHelper = loader.loadModelCopy('models/sphere')
        self.blueHelper.setColor( Vec4( 0, 0, 1, 1 ) )
        self.blueHelper.attachNewNode( self.bluePointLight.upcastToPandaNode() ) 
        self.blueHelper.setPos( 6.5+dx, -3.75+dy, 0 +dz)
        self.blueHelper.setScale(.25)
    
        self.pointLightHelper = render.attachNewNode( "pointLightHelper" )
        self.pointLightHelper.setPos(0+dx, 50+dy, 11+dz)
        self.redHelper.reparentTo( self.pointLightHelper )
        self.greenHelper.reparentTo( self.pointLightHelper )
        self.blueHelper.reparentTo( self.pointLightHelper )
    
        self.lightAttrib = self.lightAttrib.addLight( self.redPointLight ) 
        self.lightAttrib = self.lightAttrib.addLight( self.greenPointLight ) 
        self.lightAttrib = self.lightAttrib.addLight( self.bluePointLight ) 
        
        render.node().setAttrib( self.lightAttrib )

        self.pointLightsSpin = self.pointLightHelper.hprInterval(6, Vec3(360, 0, 0))
        self.pointLightsSpin.loop()
        self.arePointLightsSpinning = True
