import libneat
import random

class neatPop:
    
    def __init__(self, numIn, numOut, popSize, type=0, numHidden=0):
        genome = libneat.Genome(numIn, numOut, numHidden, type)
        random.seed()
        libneat.load_neat_params('params-dancer.ne')
        self.pop = libneat.Population(genome, popSize)
    
    #activate depth times
    #flush network
    def gen(self, sensors):
        outputs = list()
        for org in self.pop.organisms:
            org.net.load_sensors(sensors)
            for x in range(org.net.max_depth()):
                org.net.activate()
            outputs.append([(x.get_active_out()-.5)*6 for x in org.net.outputs])
        return outputs
    
       
    def evolve(self, index, gen):
        self.pop.next_gen_from_one(index)

    def mevolve(self, index, gen):
        self.pop.next_gen_from_one_mating(index)
