from pandac.PandaModules import CollisionSphere, CollisionTraverser
from pandac.PandaModules import CollisionNode, CollisionHandlerQueue 
from pandac.PandaModules import CollisionRay, GeomNode

class picker:
    """
    Handles mouse collisions with a Panda3d model.
    """
    
    def __init__(self, world):
        """
        Sets up the collision handling and the mouse ray.
        """
        self.picker = CollisionTraverser()
        self.queue = CollisionHandlerQueue()
        
        self.pickerNode = CollisionNode('mouse')
        self.pickerNP = camera.attachNewNode(self.pickerNode)
        
        self.pickerRay = CollisionRay()
        self.pickerNode.addSolid(self.pickerRay)
        
        self.picker.addCollider(self.pickerNP, self.queue)
        self.pickedObj = None
        self.pickedTag = None
        
        #world.accept('mouse1', self.click)
        
    def makePickable(self, pilot, name, visible = False):
        """
        Takes a pilot actor and a (unique) name and sets up
        a collision sphere around it.
        """
        pilot.actor.setTag('name', 'pilot-' + name)
        cnode = CollisionNode('node')
        cnode.addSolid(CollisionSphere(3,0,27,20))
        sphere = pilot.actor.attachNewNode(cnode)
        if visible:
            sphere.show()
        
    def getObjectHit(self, mpos):
        """
        Prints out a name if a collision sphere is clicked.
        """
        self.pickedObj = None
        self.pickedTag = None
        self.pickerRay.setFromLens(base.camNode, mpos.getX(), mpos.getY())
        self.picker.traverse(render)
        
        if self.queue.getNumEntries() > 0:
            self.queue.sortEntries()
            self.pickedObj = self.queue.getEntry(0).getIntoNodePath()
            
            parent = self.pickedObj
            self.pickedObj = None
            
            while parent != render:
                if parent.getTag('name')[:5] == 'pilot':
                    self.pickedObj = parent
                    self.pickedTag = parent.getTag('name')[6:]
                    return
                else:
                    parent = parent.getParent()
                
        return None
    
    
        
    def click(self):
        self.getObjectHit(base.mouseWatcherNode.getMouse())
