from direct.gui.DirectGui import *
import os

def songs_in_path_plus_dirs(path):
    Songs = []
    for root, dirs, files in os.walk(path):
        for song in files:
            name, ext = os.path.splitext(song)
            print name, ext
            if(ext == '.mid'):
                Songs.append((os.path.join(root,song), name))
    return Songs

class songList:
    def __init__(self, player):
        self.makeList()
        self.scrolledList = DirectScrolledList(pos = (.9, 0, .6),
                                               suppressMouse = 1,
                                               numItemsVisible = 10,
                                               forceHeight = 1.3,
                                               scale = .1,
                                               incButton_pos= (0,0,-12.7),
                                               decButton_pos= (0,0,1.3),
                                               incButton_scale = 4,
                                               decButton_scale = 4,
                                               items = self.buttons)
        self.scrolledList.hide()
        self.showList = DirectCheckButton(pos = (.9, 0, -.8), text = ('Show Song List'),
                                          indicatorValue = 0, command = self._show,
                                          scale = .08,textMayChange = 1)
                                     
        self.player = player
    def makeList(self):
        Songs = songs_in_path_plus_dirs('songs')
        import string
        self.buttons = []
        for path, name in Songs:
            print 'path = ', path, 'name = ', name
            self.buttons.append(DirectButton(text = name[:20], command = self.playSong, extraArgs = [path]))
    def playSong(self, song):
        self.player.pickSong(name = song)

    def _show(self, show):
        if show == 1:
            self.scrolledList.show()
            self.showList['text'] = 'Hide Song List'
        else:
            self.scrolledList.hide()
            self.showList['text'] = 'Show Song List'

#Songs that don't work              :error
#Rockafella_skank                   :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#Shake_Your_Booty                   :AttributeError: Transposer instance has no attribute 'realtime' in baseMidi line 50: self.offset = self.abs_time()*self.realtime
#12th_warrior                       :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#12th_warrior_xg                    :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#high_spirits                       :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#bjorn_lynne_12th_warrior           :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#open_pod                           :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#streetlight_fences                 :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#the_enchanted_orchard              :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#the_great-river-race               :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#the_late_one                       :ZeroDivisionError: float modulo in main line 23: measure = (pos%self.midi.measure)/self.midi.measure
#tomorrow_today                     :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3) 
#zombie_chase                       :TypeError: 'int'object not callable in EventDispatcher line 248: stream.temp((b1<<16) + (b2<<8) + b3)  
